<?php
/**
 * Copyright © 2018 Filoblu S.p.A. All rights reserved.
 */

namespace FiloBlu\MappConnector\Block\Adminhtml\System\Config\Order;

use FiloBlu\MappConnector\Block\Adminhtml\System\Config\AbstractConfig;
use Magento\Backend\Block\Template\Context;
use Magento\Framework\App\ResourceConnection;
use Magento\Sales\Model\Order\Item;

/**
 * Class OrderItem
 * @package FiloBlu\MappConnector\Block\Adminhtml\System\Config\Order
 */
class OrderItem extends AbstractConfig
{

    /**
     * Order Model
     *
     * @var Item
     */
    protected $_model;

    /**
     * @var string
     */
    protected $_id = 'order_item';

    /**
     * @var string
     */
    protected $_type = 'flat';

    /**
     * @var array
     */
    protected $_exclude = ['entity_id'];

    /**
     * @var array
     */
    protected $_additionalOptions =  [
        ['value' => 'key', 'label' => 'Key'],
        ['value' => 'order_number', 'label' => 'Order Number'],
        ['value' => 'product_uri', 'label' => 'Product Uri'],
        ['value' => 'product_main_thumbnail', 'label' => 'Product Thumbnail'],
        ['value' => 'product_attribute_set', 'label' => 'Product Attribute Set'],
        ['value' => 'order_link', 'label' => 'Order Link'],
        ['value' => 'invoice_download_link', 'label' => 'Invoice Download Link'],
        ['value' => 'shipping_address', 'label' => 'Shipping Address'],
        ['value' => 'billing_address', 'label' => 'Billing Address'],
        ['value' => 'guest_customer_firstname', 'label' => 'Guest/Customer Firstname'],
        ['value' => 'guest_customer_lastname', 'label' => 'Guest/Customer Lastname']
    ];

    /**
     * Order constructor.
     * @param Item $orderItem
     * @param Context $context
     * @param ResourceConnection $resourceConnection
     * @param array $data
     */
    public function __construct(
        Item $orderItem,
        Context $context,
        ResourceConnection $resourceConnection,
        array $data = []
    ) {
        $this->_model = $orderItem;
        parent::__construct($context, $resourceConnection, $data);
    }

}
