<?php
/**
 * Copyright © 2018 Filoblu S.p.A. All rights reserved.
 */

namespace FiloBlu\MappConnector\Model\From\Entity;

use FiloBlu\MappConnector\Model\To\Mapp\User;
use Magento\Customer\Model\Address;
use Magento\Framework\App\ResourceConnection;

/**
 * Class CustomerShippingAddress
 * @package FiloBlu\MappConnector\Model\From\Entity
 */
class CustomerShippingAddress extends AbstractEntity implements EntityInterface
{

    /**
     * Entity
     *
     * @var string
     */
    protected $_entity = 'customer_shipping_address';

    /**
     * Magento Entity Model
     *
     * @var string
     */
    protected $_entityModel = Address::class;

    /**
     * Magento Entity Model Id
     *
     * @var string
     */
    protected $_entityModelPrimary = 'parent_id';

    /**
     * Magento Entity Model Related Id
     *
     * @var string
     */
    protected $_entityModelRelatedPrimary = 'entity_id';

    /**
     * Mapp Resource Model
     *
     * @var string
     */
    protected $_entityMappResource = User::class;

    /**
     * Mapp Resource Model Id
     *
     * @var array
     */
    protected $_entityMappPrimary = ['primaryDB' => 'parent_id', 'primaryMapp' => 'email'];

    /**
     * User Type
     *
     * @var string
     */
    protected $_userType = 'customer';

    /**
     * @var Address $address
     */
    protected $_model;

    /**
     * @var string
     */
    protected $_xmlConfigPath = 'mappconnector/customer_mapping/customer_shipping_address';

    /**
     * Customer constructor.
     * @param Address $address
     * @param ResourceConnection $resourceConnection
     */
    public function __construct(
        Address $address,
        ResourceConnection $resourceConnection
    ) {
        $this->_model = $address;
        parent::__construct($resourceConnection);
    }

    /**
     * @param $primary
     * @param $id
     * @return
     */
    public function getObjectData($primary, $id)
    {
        return $this->_model->getCollection()
            ->addAttributeToSelect('*')
            ->addFieldToFilter($primary, $id)
            ->getFirstItem()
            ->getData();
    }
}
